#include "stdio.h"
#include "dos.h"

#include "seta01x.h"

/* modoin=0 es modo standar para cualquier puerto paralelo
   modoin=1 es modo bidireccional, puede no funcionar
*/

#define TAMAEPROM 32768
char EPROM[]="27256 12,5V";

void c_control(char a,char b,char c1,char c2);
unsigned char c_in(unsigned char p);
void c_out(unsigned char p, unsigned char d);
/* void control(void); */

void gotodi(unsigned long int di);
void seedi(int x,int y,int num,unsigned long int di);
void seebin(unsigned char c);
void see_eprom(void);
void menuWdi();
void deleprom(void);
void menuWfiD(void);
void menuWfi(void);
void menuVpp(void);

void recByte(unsigned char dato);
void grabarFD(unsigned long int di,char *nombre);
void delDD(unsigned long int di,unsigned long int di1);
void grabarD(unsigned long int di,unsigned char dato);
void readeprom(unsigned long int bytes,char *nombre);
void leer(void);



unsigned char modoin=0;
unsigned char xa,xb,xc1,xc2,da,db,dc;
char *led="**";

unsigned int retardo=10;

main()
{
int z,z1;
unsigned long int contador;
unsigned char zc;
unsigned char u,te,tez;
	xa=xb=xc1=xc2=1;
	c_control(xa,xb,xc1,xc2);
	xb=xc1=xc2=1; xa=0;
	c_control(xa,xb,xc1,xc2);
inicio:

	te=0; tez=1;
   while(te!=27)
	{
	 te=inkey();
	 if(te!=tez)
		{
		 cls();
		 INK=14; PAPER=0;
		 printc(24,0,"Programador del EPROM");
		 printc(24,1,EPROM);
		 printc(24,2,"   (c) SETA 2001    ");
		 INK=3;
		 printc(24,7,"1-Ver Eprom");
		 printc(24,8,"2-Leer Eprom a fichero");
		 printc(24,9,"3-Grabar Direccin Eprom");
		 printc(24,10,"4-Grabar Eprom desde fichero");
		 printc(24,11,"5-Grabar Eprom desde fichero a direccin");
		 printc(24,12,"6-Borrar Eprom entre dos direcciones");
		 printc(24,13,"7-Cambia retardo");
		 printc(24,14,"8-Ajuste de la tension Vpp");
		 INK=15;
		 if(modoin==0) printc(50,21,"Modo standard           "); else 	 printc(50,23,"Modo Bidireccional");
		 switch(te)
			{
			 case '1':
				see_eprom();
			 break;
			 case '2':
				leer();
			 break;
			 case '3':
				menuWdi();
			 break;
			 case '4':
				menuWfi();
			 break;
			 case '5':
				menuWfiD();
			 break;
			 case '6':
				deleprom();
			 break;
			 case '7':
					cls();
					printf("\nIntroduce el retardo\n");
					printf("--------------------\n");
					printf("Depende del tipo de ordenador\n");
					printf("Para un 486/100MHZ entre 20 y 30\n");
					printf("Para uno mas rapido un numero mayor\n");
					printf("Retardo actual %d. Introduce tu retardo=",retardo);
				   scanf("%ui",&retardo);
			 break;
			 case '8':
				 menuVpp();
			 break;
			}
		 }

	 tez=te;
	 impri(0,0,32);
	 espera(1);
	}
fin:
 exit();
}

/* ---graba un byte en la posicin actual de memoria */
void recByte(unsigned char dato)
{
 unsigned int z,z1;
		/* PUERTO B COMO ESCRITURA */
		xb=0;
		c_control(xa,xb,xc1,xc2);
		c_out('b',dato);
		c_out('a',12); /* ce=g=1 */
		/* 25V a vpp o 12,5*/
		c_out('a',28); /* ce=g=1  vpp=12,5 */
		for(z=0;z<10000;z++)for(z1=0;z1<retardo;z1++);
		c_out('a',20); /* ce=0  g=1  vpp=12,5 */
		/*retardo de 50 ms */
		for(z=0;z<retardo;z++) for(z1=0;z1<100;z1++);
		c_out('a',28); /* ce=g=1  vpp=12,5 */
		c_out('a',12); /* ce=g=1 */
		/* PUERTO B COMO LECTURA */
		xb=1;
		c_control(xa,xb,xc1,xc2);
}

void menuVpp()
{
 unsigned char te;
	cls(); locate(0,0);
	INK=14; PAPER=0;
	printc(18,0,"AJUSTE DE LA TENSION VPP");
	printc(18,1,EPROM);
	printf("\n\n1-Quitar la Eprom, no hace falta desconectar la alimentacin");
	printf("\n\n2-Coloca el voltimetro en el pin1 del puente n1");
	printf("\n\n3-Varia el potenciometro a la tension de programacin");
	printf("\n\n  Pulsa c ->Vpp    n ->5V    ESC salir");
	te=255;
	while(te!=27)
		{ te=inkey(); if(te=='c')c_out('a',28); if(te=='n')c_out('a',12);}
	c_out('a',12);
}
/* graba eprom desde un fichero a una direccin */
void grabarFD(unsigned long int di,char *nombre)
{
 unsigned int z,z1;
 unsigned char dato,te;

  dato=0;
  gotodi(di);
  pf=fopen(nombre,"rb");
  if(pf==0)
	{
	 printf("Error abriendo fichero %s    pulsa ESC ",nombre);
	 te=255; while(te!=27){ te=inkey();}
	 goto fin;
	}
  for(;di<=TAMAEPROM;di++)
  {
	dato=getc(pf);
	if(feof(pf)!=0) break;
	c_out('a',4); c_out('a',0);
	z=c_in('b');
	c_out('a',12);
	if(dato!=z)
		{
		 recByte(dato);
		}
	/*comprobar escritura */
	c_out('a',4); c_out('a',0);
	z=c_in('b');
	c_out('a',12);
	if(z!=dato)
	{
	 printf("Error escribiendo dato %d en direccin %d\n",dato,di);
	 te=255;
	}
	/* Direccin siguiente*/
	c_out('a',1);
	c_out('a',0);
	if(feof(pf)!=0) break;
	}
 close(pf);
fin:
 if(te==255)
	{
	 printf("\nPulsa ESC para salir\n\n");
	 while(te!=27){ te=inkey();}
	}
}

void menuWfi(void)
{
 unsigned long  di;
 unsigned char te;
				 cls(); locate(0,0);
				 INK=14; PAPER=0;
				 printc(18,0,"GRABA UN FICHERO A LA DIRECCION 0");
				 printf("\nIntroduce nombre de fichero\n");
				 printf("------------------------------\n");
				 scanf("%s",&VARI);
				 di=0;
				 printf("\n\n\n\nDireccin de inicio->%ld\n",di);
				 printf("\nFichero   ->%s\n",VARI);
				 INK=12; PAPER=0; printc(1,20,"Pulsa c para confirmar  ESC salir");
				 INK=7;
	te=255;
   while(te!=27)
	{
	 switch(te)
			{
			 case 'c':
			  printf("\nGRABANDO\n");
			  grabarFD(di,VARI);

			 break;
			}
	 if('c'==te) break;
	 te=inkey();
	}
}


void menuWfiD(void)
{
 unsigned long  di;
 unsigned char te;
				 cls(); locate(0,0);
				 INK=14; PAPER=0;
				 printc(18,0,"GRABA A UNA DIRECCION UN FICHERO");
				 printf("\n\nIntroduce la direccion de inicio\n");
				 printf("---------------------------------\n");
				 scanf("%ld",&di);
				 printf("\nIntroduce nombre de fichero\n");
				 printf("------------------------------\n");
				 scanf("%s",&VARI);
				 printf("\n\n\n\nDireccin de inicio->%ld\n",di);
				 printf("\nFichero   ->%s\n",VARI);
				 INK=12; PAPER=0; printc(1,20,"Pulsa c para confirmar  ESC salir");
				 INK=7;
	te=255;
   while(te!=27)
	{
	 switch(te)
			{
			 case 'c':
			  printf("\nGRABANDO\n");
			  grabarFD(di,VARI);

			 break;
			}
	 if('c'==te) break;
	 te=inkey();
	}
}

/* Pone a cero desde la direccin di a la direccin di1 */
void deleprom(void)
{
 unsigned long  di,di1;
 unsigned char te;
				 cls(); locate(0,0);
				 INK=14; PAPER=0; printc(18,0,"BORRANDO DIRECCIONES EPROM");
				 INK=7;
				 printf("\n\nIntroduce la direccion de inicio\n");
				 printf("---------------------------------\n");
				 scanf("%ld",&di);
				 if(di<0) goto fin;
				 printf("\nIntroduce la direccion de fin\n");
				 printf("------------------------------\n");
				 scanf("%ld",&di1);
				 if(di1<di)goto fin;
				 printf("\n\n\n\nDireccin de inicio->%ld\n",di);
				 printf("\nDireccin de fin   ->%ld\n",di1);
				 INK=12; PAPER=0; printc(1,20,"Pulsa c para confirmar  ESC salir");
				 INK=7;
	te=255;
   while(te!=27)
	{
	 switch(te)
			{
			 case 'c':
			  printf("\nBORRANDO\n");
			  delDD(di,di1);
			 break;
			}
	 if('c'==te) break;
	 te=inkey();
	}
fin:
;
}
/* Grabar Direccin de Memoria */
void menuWdi()
{
unsigned long int contador;
unsigned char te,tez,dato;
char CADE[80];
	xb=xc1=xc2=1; xa=0;
	c_control(xa,xb,xc1,xc2);
	contador=0; dato=0;
	cls();
inicio:
	te=0; tez=1;
   while(te!=27)
	{
	 	switch(te)
			{
	 		 case '8':
				if(dato&1) dato-=1; else dato+=1;
			 break;
			 case '7':
				if(dato&2) dato-=2; else dato+=2;
			 break;
			 case '6':
				if(dato&4) dato-=4; else dato+=4;
			 break;
			 case '5':
				if(dato&8) dato-=8; else dato+=8;
			 break;
			 case '4':
				if(dato&16) dato-=16; else dato+=16;
			 break;
			 case '3':
				if(dato&32) dato-=32; else dato+=32;
			 break;
			 case '2':
				if(dato&64) dato-=64; else dato+=64;
			 break;
			 case '1':
				if(dato&128) dato-=128; else dato+=128;
			 break;
			 case 'z':
				xb=xc1=xc2=1; xa=0; c_control(xa,xb,xc1,xc2);
			 break;
			 case '*':
				contador=0;
			 break;
			 case 'g':
				 cls(); locate(10,10);
				 printf("\nIntroduce el direccion\n");
				 printf("----------------------\n");
				 scanf("%ui",&contador);
				 if(contador<0||contador>TAMAEPROM) contador=0;
				 gotodi(contador);
				 c_out('a',4); c_out('a',0);
				 dato=c_in('b');
				 c_out('a',12);
			 break;
			 case '+':
				contador+=1;
				gotodi(contador);
				c_out('a',4); c_out('a',0);
				dato=c_in('b');
				c_out('a',12);
			 break;
			 case '-':
				if(contador>0 )contador-=1;
				gotodi(contador);
                c_out('a',4); c_out('a',0);
				dato=c_in('b');
                c_out('a',12);
			 break;
			 case 'm':
					cls();
					printf("\nIntroduce el retardo\n");
					printf("--------------------\n");
					printf("Depende del tipo de ordenador\n");
					printf("Para un 486/100MHZ entre 20 y 30\n");
					printf("Para uno mas rapido un numero mayor\n");
					printf("Retardo actual %d. Introduce tu retardo=",retardo);
				   scanf("%ui",&retardo);
			 break;
			 case'w':
				INK=9; printc(2,10,"GRABANDO DIRECCION, pulsa c para confirmar");
				tez=0;
				while(tez==0)
				{
				 tez=inkey();
				 if(tez=='c')
					{
					 grabarD(contador,dato);
					}
				}
			 break;
			}
	 if(te!=0||tez==1)
		{
		 tez=0;
		 cls();
		 INK=14; PAPER=0;
         printc(18,0,"GRABAR DIRECCION EPROM ");
		 printc(18,1,EPROM);
		 INK=7;
		 seedi(2,2,1,contador);
		 seebin(dato);
		 sprintf(CADE,"CHAGE %.8lu  DATO %.3d %.2X %s",contador,dato,dato,VARI);
		 INK=14; printc(2,5,CADE);
		 sprintf(CADE,"RETARDO  %d",retardo);
		 INK=12; printc(2,19,CADE);
		 INK=15;
		 printc(2,23,"Teclas +/-=Direccin *=reset g=goto (1..8)=byte m=retrardo w=grabar");
		}
	 espera(2);
	 te=inkey();
	}
}
/*  Ver Eprom */
void see_eprom(void)
{
unsigned long int contador;
unsigned char te,tez;
	xb=xc1=xc2=1; xa=0;
	c_control(xa,xb,xc1,xc2);
	contador=0;
	cls();
inicio:
	te=0; tez=1;
   while(te!=27)
	{
	 te=inkey();
     switch(te)
			{
			 case 'z':
				xb=xc1=xc2=1; xa=0; c_control(xa,xb,xc1,xc2);
			 break;
			 case '*':
				contador=0;
			 break;
			 case 'g':
				cls(); locate(10,10);
				printf("\nIntroduce el direccion\n");
				printf("----------------------\n");
				scanf("%ui",&contador);
			 break;
			 case '+':
				contador+=20;
			 break;
			 case '-':
				if(contador>19 )contador-=20;
			 break;
			}
	 if(te!=0||tez!=0)
		{
		tez=0;
		 cls();
		 INK=14; PAPER=0;
		 printc(24,0,"VER EPROM");
		 printc(24,1,EPROM);
		 seedi(2,2,20,contador);
		 INK=15;
		 printc(2,23,"Teclas +/-=Direccin *=reset g=goto");
		}
	 espera(2);
	}
}
/*--Va a una direccin--*/
void gotodi(unsigned long int di)
{
 unsigned long int z;
	c_out('a',14); /*reset*/
	for(z=0;z<di;z++)
		{
		 c_out('a',13); c_out('a',12);
		}
}
/* Representa una direcciones en una columna de pantalla  en el lugar x */
void seedi(int x,int y,int num,unsigned long int di)
{
 int z;
 unsigned char c;
	INK=7;
	gotodi(di);
	for(z=0;z<num;z++)
		{
		 c_out('a',4); c_out('a',0);
		 c=c_in('b');
		 c_out('a',12);
		 seebin(c);
		 locate(x,y+z);
		 printf("DIREC %.8lu  DATO %.3d %.2X %s\n",di,c,c,VARI);
		 c_out('a',13); c_out('a',12);
		 di++;
		}
}
/* Coloca en VARI la imagen binaria de c */
void seebin(unsigned char c)
{
 int z;
	for(z=0;z<8;z++)
		{
		 if(c&128)VARI[z]='1';else VARI[z]='0';
		 c=c<<1;
		}
	VARI[8]=0;
}

/* Borra entre dos direcciones */
void delDD(unsigned long int di,unsigned long int di1)
{
 unsigned int z,z1;
 unsigned char dato;
 unsigned long int dix;

  dato=0;
  gotodi(di);
  for(;di<=di1;di++)
  {
	c_out('a',4); c_out('a',0);
	z=c_in('b');
	c_out('a',12);
	if(dato!=z)
		{
		 recByte(dato);
		}
	/* Direccin siguiente*/
	c_out('a',1);
	c_out('a',0);
  }
}


/* Grabar una direccin con un dato */
void grabarD(unsigned long int di,unsigned char dato)
{
 unsigned int z,z1;

	gotodi(di);
	c_out('a',4); c_out('a',0);
	z=c_in('b');
	c_out('a',12);
	if(dato==z)
	{
		 printf("\nDato a graba igual al grabado, pulsa enter");
		 getchar();
	}
	else
	{
	 recByte(dato);
	}
}

void leer()
{
unsigned long int uz;
unsigned char te;
	cls();
	locate(0,0);
	cls();
	INK=14; PAPER=0;
	printc(2,5,"LEE LA EPROM Y LO TRAFIERE A FICHERO eprom.dat");
	INK=7;
	readeprom(TAMAEPROM,"eprom.dat");
	INK=15;
	printc(2,20,"EPROM TRANSFERIDA A FICHERO    Pulsa Esc para salir");
	te=0;
	while(te!=27)
	{
	 te=inkey();
	}
}
/* Lee Kytes a un fichero */
void readeprom(unsigned long int bytes,char *nombre)
{
unsigned long int z;
unsigned char c;
FILE *pf;
int z1;
	xa=0; xb=1;
	c_control(xa,xb,xc1,xc2);
	c_out('a',2);
	pf=fopen(nombre,"wb");
	if(pf==0){printf("Error abriendo fichero eprom.dat"); goto fin;}
	z1=0;
	for(z=0;z<bytes;z++)
		{
		 c_out('a',4); c_out('a',0);
		 c=c_in('b');
		 c_out('a',12);
		 seebin(c);
		 locate(2,10);
		 if(z1>100)
			{
			 z1=0;
			 printf("Direccion %lu    Dato->%d",z,c);
			}
		 c_out('a',13); c_out('a',12);
		 putc(c,pf);
		 z1++;
		}
    printf("Direccion %lu    Dato->%d",z,c);
	fclose(pf);
fin:
;
}


/* solo modo 0 de 8255 */
/* 0=salida  1=entrada */
void c_control(char a,char b,char c1,char c2)
{
unsigned char z;
	xa=xb=xc1=xc2=0;
	z=0;
	if(c2>0) {z=8; xc2=1;}
	if(b>0) {z+=2; xb=1;}
	if(c1>0) {z+=1; xc1=1;}
	if(a>0) {z+=16; xa=1;}
	z+=128;
	c_out('x',z);
}

unsigned char c_in(unsigned char p)
{
unsigned char c,c1,byte;
int z;
	byte=0;
	switch(p)
			{
			case 'a':
				 if(modoin==0)
				{
				 outportb(890,14);
				 outportb(890,15);
				 for(c1=0;c1<8;c1++)
					{
					 byte=byte>>1;
					 outportb(888,c1); outportb(888,c1);
					 c=inportb(889)&32; c=inportb(889)&32;
					 if(32==c) byte=byte|128;
					}
				 outportb(890,14);
                }
				 else
				 {
				  outportb(890,14);
				  outportb(890,15);
				   outportb(890,15+32);
				   byte=inportb(888);
				  outportb(890,14);
				 }
			 break;
			 case 'b':
				if(modoin==0)
				{
				 outportb(890,6);
				 outportb(890,7);
				 for(c1=0;c1<8;c1++)
					{
					 byte=byte>>1;
					 outportb(888,c1); outportb(888,c1);
					 c=inportb(889)&32; c=inportb(889)&32;
					 if(32==c) byte=byte|128;
					}
				  outportb(890,6);
				 }
				 else
				 {
				  outportb(890,6);
				 outportb(890,7);
				   outportb(890,7+32);
				   byte=inportb(888);
				 outportb(890,6);
				 }
			 break;
			 case 'c':
				if(modoin==0)
				{
				 outportb(890,12);
				 outportb(890,13);
				 for(c1=0;c1<8;c1++)
					{
					 byte=byte>>1;
					 outportb(888,c1); outportb(888,c1);
					 c=inportb(889)&32; c=inportb(889)&32;
					 if(32==c) byte=byte|128;
					}
				 outportb(890,12);
				}
				else
				{
				 outportb(890,12);
				 outportb(890,13);
				   outportb(890,13+32);
				   byte=inportb(888);
				 outportb(890,12);
				}
			 break;
			}
	return(byte);
}

/* p= a,b,c,x siendo x de control */
void c_out(unsigned char p, unsigned char d)
{
	switch(p)
			{
			 case 'a':
				da=d;
/*				printf("c_out A= %d\n",d); */
				outportb(890,14);
				outportb(888,d);
				outportb(890,10);
				outportb(890,14);
			 break;
			 case 'b':
				db=d;
/*				printf("c_out B= %d\n",d); */
				outportb(890,6);
				outportb(888,d);
				outportb(890,2);
				outportb(890,6);
			 break;
			 case 'c':
				dc=d;
/*				printf("c_out C= %d\n",d); */
				outportb(890,12);
				outportb(888,d);
				outportb(890,8);
				outportb(890,12);
			 break;
			 case 'x':
/*				printf("Control c_out %d\n",d); */
				outportb(890,4);
				outportb(888,d);
				outportb(890,0);
				outportb(890,4);
			 break;
			}
}